import { ListSOP } from '../../libappsop/listsop';
import { FormSOP } from '../../libappsop/formsop';
import { DialogFulfillmentTarget } from '../dialogs/dialog.fulfillmenttarget';

/**
 * Fulfillment target form.
 */
export class FormFulfillmentTarget extends FormSOP {
  public listFulfillmentTarget = new ListFulfillmentTarget();

  public constructor() {
    super('FormFulfillmentTarget');
  }
}

/**
 * Fulfillment Target list in Fulfillment Target form.
 */
class ListFulfillmentTarget extends ListSOP<DialogFulfillmentTarget, ListFulfillmentTargetColumn> {
  public constructor() {
    super('ListFulfillmentTarget', new DialogFulfillmentTarget());

    // Set primary key column name(s), to display in error message when assert fails
    this.rowPrimaryColumnNames = {Name: ''};
  }
}

export interface ListFulfillmentTargetColumn {
  Name?: string;
  Start?: string;
  End?: string;
  'Target (%)'?: string;
}

const listFulfillmentTargetContextMenuItem = {
  Create: { ContextMenu: 'listContextMenuFulfillmentTarget', Name: 'MenuCreate', Label: 'Create' },
  Edit: { ContextMenu: 'listContextMenuFulfillmentTarget', Name: 'MenuEdit', Label: 'Edit' },
};

export { listFulfillmentTargetContextMenuItem as ListFulfillmentTargetContextMenuItem };
